/**
 * about:kitchensink handler
 * (c) 2005 Myen
 * based on Mozilla's nsAboutRedirector.cpp and related files
 * License: MPL
 */


const FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
const THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
 
function getProductID() {
  try {
    // Works on Firefox 1.0+ and Future SeaMonkey's
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                           .getService(Components.interfaces.nsIXULAppInfo);
    // Use App info if possible
    return appInfo.ID;
  }
  catch(ex) {}
  // only works on Gecko 1.8 and higher (if above doesn't return)
  if ('nsIChromeRegistrySea' in Components.interfaces) {
    return 'SeaMonkey';
  }  
}

function cmdLineTest(){}

var nsICommandLine = Components.interfaces['nsICommandLine'];

cmdLineTest.prototype = {
	
/* nsICommandLineHandler */

    /* void handle(in nsICommandLine aCommandLine) */
    handle: function (aCommandLine) {
        aCommandLine.preventDefault = false; 		
        //window.alert('in minimizeToTrayCmdLine');
        if (nsICommandLine.STATE_INITIAL_LAUNCH != aCommandLine.state)
            return;
        if (aCommandLine.handleFlag("turbo", false)) {
            
			
            var productID = getProductID();			
            var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                .getService(Components.interfaces['nsIWindowWatcher']);
            var args = Components.classes["@mozilla.org/supports-string;1"]
                .createInstance(Components.interfaces['nsISupportsString']);
            if(productID == FIREFOX_ID) {
                // running under Firefox
                wwatch.openWindow(
                    null,	// parent
                    "chrome://minimizetotray/content/turbo.xul",	//url
                    "cmdLineTestWindow",	// target
                    "chrome,dialog=no,all,width=0,height=0", // features
                    args // args
                    );  
				aCommandLine.preventDefault = true;	
			} else if(productID == THUNDERBIRD_ID) {
                // running under Thunderbird
            
			} else {
              // another app
            
			}
			
			     
			//var hackywindow = wwatch.openWindow(
			//	null,	// parent
			//	"about:nothing",	//url
			//	null,	// target
			//	null, // features
			//	null // args
			//	);
			//var realwindow = hackywindow.open('chrome://minimizetotray/content/turbo.xul','','left=-100,top=-100,chrome,dialog=no,all,width=300,height=300');  	
		}
	},
	
	/* readonly attribute AUTF8String helpInfo */
	get helpInfo() {
		return
			"Testing command line handler; kill task to exit";
	},

/* nsISupports */
	QueryInterface: function (aIID) {
		var interfaces = [
			'nsISupports',
			'nsICommandLineHandler'
			];
		for (var index in interfaces) {
			if (aIID.equals(Components.interfaces[interfaces[index]]))
				return this;
		}
		throw this.C_RESULTS['NS_ERROR_NO_INTERFACE'];
    }
}
