var err = UNEXPECTED_ERROR;

const localePacks = {
    "en-US": true,
    "ca-AD": true,
    "cs-CZ": true,
    "da-DK": true,
    "de-DE": true,
    "es-ES": true,
    "eu-ES": true,
    "fi-FI": true,
    "fr-FR": true,
    "fy-NL": true,
    "el-GR": true,
    "hu-HU": true,
    "it-IT": true,
    "lt-LT": true,
    "ja-JP": true,
    "nb-NO": true,
    "nl-NL": true,
    "pl-PL": true,
    "pt-BR": true,
    "ru-RU": true,
    "sl-SL": true,
    "sk-SK": true,
    "sv-SE": true,
    "zh-CN": true,
    "zh-TW": true
    
};

var localesToInstall = [];
var SetupLocaleDB    = null;

function DoLanguageStuff()
{
	var languageAttrib = decodeURIComponent(Install.arguments);
	var SetupLocale = "";
	if (languageAttrib in localePacks)
	{
		localesToInstall.push(languageAttrib);
		SetupLocale = languageAttrib;
	}
	else
	{
		for (s in localePacks)
		      localesToInstall.push(s);
		SetupLocale = "en-US";	
	}
	SetupLocaleDB = loadResources(SetupLocale);
}

try {
    DoLanguageStuff();
    
	err = initInstall(
		"minimizetotray", 
		"@mook.example.com/minimizetotray,version=0.0.1", 
		"0.0.1.2006102615+");
	if (err)
		throw('initInstall: ' + err);
	
	// Windows only, for now.
	// TODO: figure out the difference between Win32 and Win64
	{
		var plat = new String(Install.platform);
		plat = plat.substring(0,3);
		if (plat != 'Win') {
			err = UNABLE_TO_LOAD_LIBRARY;
			throw(
				'This package contains binary components ' +
				'that are designed for Windows only.  Help me port it.');
		}
	}
	
	var chromeFolder = Install.getFolder("Profile", "Chrome");
	
	err = Install.addFile("jar",
	        "chrome/minimizetotray.jar",
	        chromeFolder,
	        null);
	if (err)
		throw('addFile: jar: ' + err);
	
	var jarFile = Install.getFolder(chromeFolder, "minimizetotray.jar");
	
	err = Install.registerChrome(
			PACKAGE | PROFILE_CHROME, 
			jarFile, 
			"content/minimizetotray/");
	if (err)
		throw('registerChrome: chrome: ' + err);
	
	// Language packs
	for (s in localesToInstall) {
        err = Install.registerChrome(
                LOCALE | PROFILE_CHROME, 
                jarFile, 
                "locale/" + localesToInstall[s] + "/minimizetotray/");
        if (err)
            throw('registerChrome: locale: ' + err);
    }

	err = Install.registerChrome(
			SKIN | PROFILE_CHROME, 
			jarFile, 
			"skin/classic/minimizetotray/");
	if (err)
		throw('registerChrome: skin: ' + err);
	
	var componentsFolder = Install.getFolder("Components");
	
	err = Install.addFile("components",
	        "components/mintray-9178506d-2005072516-trunk.dll",
	        componentsFolder,
	        null);
	if (err)
		throw('addFile: bin: ' + err);
	
	err = Install.addFile("components",
	        "components/minimizetotray.xpt",
	        componentsFolder,
	        null);
	if (err)
		throw('addFile: xpt: ' + err);
	
    err = Install.performInstall();
    if (err)
    	throw('performInstall: ' + err);
	
    err = SUCCESS;

} catch (message) {
	logComment('catching something');
	logComment('err is ' + err);
	// we can't possibly be trying to catch no error
	if (SUCCESS == err)
		err = getLastError() || SCRIPT_ERROR;
	logComment(message);
	cancelInstall(err);
}

